#!/usr/bin/perl

#    vessel.pl - Vessel utility
#    Copyright (C) 2000 Michael Jung
#    e-mail: miju@phantasia.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$| = 1;

$FILE_LOCATION = "../cgi-tmpl/vessel/";

#########
### INPUT
#########

$q = new CGI;

foreach (1..90) {
    ${"A$_"} = $q->param("\$A$_") if ($q->param("\$A$_") ne "");
}
foreach (1..110) {
    ${"B$_"} = $q->param("\$B$_") if ($q->param("\$B$_") ne "");
}
$kamba = 1 if ($q->param("kamba") ne "");
$leakage = 1 if ($q->param("leakage") ne "");

$rr = "";
if ($q->param("action") eq "Reroll Hull") {
    $rr = "H"; $q->param(-name=>"action",-value=>"FORM");
}

if ($q->param("action") eq "Reroll Rigging") {
    $rr = "R"; $q->param(-name=>"action",-value=>"FORM");
}

if ($q->param("action") eq "Reroll Tightness") {
    $rr = "T"; $q->param(-name=>"action",-value=>"FORM");
}

if ($q->param("action") eq "Reroll Sailing Grade") {
    $rr = "SG"; $q->param(-name=>"action",-value=>"FORM");
}

if ($q->param("action") eq "Reroll Oar Grade") {
    $rr = "OG"; $q->param(-name=>"action",-value=>"FORM");
}

#########
### CONSTANTS
#########

%type = ("Dak" =>
	 [ 64, 84, 0.4,  0.55, "R",  35, "s", "-", 70, "*", 70, 65, 7],
         "Dragon" =>
         [120,  0, 0.2,  0.4,  "S",  80, "s", 70,  75, "*", 55, 65, 6],
         "Karune" =>
         [  0, 79, 0.36, 0.5,  "R",  55, "m", "-", 65, " ", 70, 60, 8],
         "Laru" =>
         [150,  0, 0.2,  0.4,  "S2", 70, "v", 85,  60, " ", 55, 55, 5],
         "Laru-Mar" =>
         [ 90,120, 0.25, 0.4,  "S2", 60, "v", 65,  55, " ", 65, 55, 6],
         "Nivik" =>
         [ 60,  0, 0.33, 0.5,  "S",  60, "s", "-", 65, "*", 55, 65, 5],
         "Pinda" =>
         [ 21,  0, 0.4,  0.4,  "S",  65, "c", 80,  75, "*", 55, 60, 3],
         "Raem" =>
         [  0, 84, 0.36, 0.5,  "S2", 55, "v", "-", 60, " ", 65, 55, 5],
         "Talbar" =>
	 [ 42,  0, 0.38, 0.3,  "S",  50, "c", 50,  60, "*", 55, 60, 4],
	 "Venar" =>
	 [ 60,  0, 0.33, 0.5,  "S",  60, "v", "-", 55, " ", 55, 55, 4]
    );

%sail = ( "s" => ["Square",2], "m" => ["Mixed",2.5],
          "c" => ["Square",2], "v" => ["Venyn",3] );

%wspeed = ( "Square" => ["2/7/12","2/8/15","3/9/18","4/10/21","4/11/24"],
           "Mixed" =>  ["2/6/10","3/7/12","4/8/14","4/9/16", "5/10/18"],
           "Venyn" =>  ["3/5/8", "4/6/9", "4/7/10","5/8/11", "5/9/12"] );

@skill = ( [0.50, 0.27, 0.00, 0.00],
           [0.60, 0.39, 0.00, 0.00],
           [0.69, 0.50, 0.14, 0.00],
           [0.87, 0.60, 0.27 ,0.00],
           [0.94, 0.69, 0.39, 0.14],
           [1.00, 0.87, 0.50, 0.27],
           [1.05, 0.94, 0.60, 0.39],
           [1.10, 1.00, 0.69, 0.50],
           [1.15, 1.05, 0.87, 0.60],
           [1.19, 1.09, 0.94, 0.69],
           [1.22, 1.12, 1.00, 0.87],
           [1.24, 1.14, 1.05, 0.94],
           [1.25, 1.15, 1.09, 1.00] );

@grades = (30, 55, 75, 90);

#########
### CALCULATIONS
#########

### Primitives

# Shipyard Values
$A90 = 1 if (precond("!A90"));
$A91 = 1 if (precond("!A91"));

# Vessel Name
$A70 = "Default" if (precond("!A70"));

# Vessel Owner
$A71 = "Captain Default" if (precond("!A71"));

# Vessel Type
$A72 = "Pinda" if (precond("!A72"));

# Port of Registry
$A73 = "Default" if (precond("!A73"));

# Port Built
$A1 = $A73 if (precond("!A1"));

# Shipwright (ML)
$A2 = "Default (70)" if (precond("!A2"));

# Date of Laying Keel
$A3 = "1.1.720" if (precond("!A3"));

# Length
$A9 = "12ft" if (precond("!A9"));

# Vessel Cost
$A7pre = $A9 * $A9 * $ {$type{$A72}}[12];

# Total Mandays
$A6pre = round ($A7pre / 6);

# Beam
$A10 = (round(10 * $A9 * $ {$type{$A72}}[2])/10)."ft" if (precond("!A10"));

# Depth
$A11 = (round(10 * $A10 * $ {$type{$A72}}[3])/10)."ft" if (precond("!A11"));

# Draft
$A12 = (round(6 * $A11)/10)."ft" if (precond("!A12"));

# Freeboard
$A13 = ($A11 - $A12)."ft" if (precond("!A13"));

# Masts
if (precond("!A14")) {
    if ($A9 <= $ {$type{$A72}}[0]) { $A14 = "1(pine)"; }
    elsif ($A9 <= $ {$type{$A72}}[1]) { $A14 = "2(pine)"; }
    else { $A14 = "3(pine)"; }
}

# Height
$A15 = ($A10 * 3)."ft" if (precond("!A15"));

# Cabins
$A21 = "1 (Captain)" if (precond("!A21"));
foreach my $i (16..20) { $ {"A".$i} = "-" if (precond("!A".$i)); }

$A22pre = 0;
foreach (16..21) {
    if ($ {"A".$_} =~ /(\d+)/) {
	$A22pre += ($1 + 1);
	$A7pre += ($1 + 1) * 60;
	$A6pre += ($1 + 1) * 20;
    }
}
$A22pre .= "tuns";

# Sailing Crew
$A23 = " " if (precond("!A23"));

# Other Crew
$A24 = " " if (precond("!A24"));

# Passengers
$A25 = " " if (precond("!A25"));

# Total Aboard
$A26pre = 0;
foreach (23..25) {
    if ($ {"A".$_} eq " ") { $A26pre = " "; last; }
    $A26pre += $ {"A".$_};
}

# Seamanship
$A27 = " " if (precond("!A27"));
$A31 = " " if (precond("!A31"));

# Shipwright
$A28 = " " if (precond("!A28"));
$A32 = " " if (precond("!A32"));

# HR
$A29 = " " if (precond("!A29"));
$A33 = " " if (precond("!A33"));

# Fatigue
$A30 = " " if (precond("!A30"));
$A34 = " " if (precond("!A34"));

# Pilot & Chippy
$A75 = " " if (precond("!A75"));
$A35 = " " if (precond("!A35"));
$A36 = " " if (precond("!A36"));
$A37 = " " if (precond("!A37"));

# Provisions
$A38 = " " if (precond("!A38"));
$A39 = " " if (precond("!A39"));

# Rigging
$A45pre = $ {$type{$A72}}[11] + round($A10 / 3);
$A46 = " " if (precond("!A46"));
$A47 = " " if (precond("!A47"));

# Gross Burden
$A62 = round($A9 * $A11 * $A10/10)/10 if (precond("!A62"));

# Repair Factor
$A8 = int($A62/10)/10 if (precond("!A8"));
$A8 = 1 if ($A8 < 1);

# Steering
if (precond("!A48")) {
    $A48 = $ {$type{$A72}}[4];
}

# Provisions/Lockers
$A64 = 0 if (precond("!A64"));

if ($A64 =~ /(\d+)/) {
    $A6pre += 8 * $1;
    $A7pre += 48 * $1;
}

# Spares/Storerooms
$A65 = int($A62 / 10) if (precond("!A65"));

if ($A65 =~ /(\d+)/) {
    $A6pre += 6 * $1;
    $A7pre += 36 * $1;
}

# Other
$A66 = " " if (precond("!A66"));

# Other
$A67 = " " if (precond("!A67"));

# Sailing Grade
if (precond("!A49")) {
    $A49pre = $ {$sail{$ {$type{$A72}}[6]}}[0];
}
else {
    ($A49pre) = ($A49 =~ /\(([A-Za-z]+)\)/);
}

# VCF
$A76 = int($A9/10) + $ {$sail{$ {$type{$A72}}[0]}}[1] * substr($A14,0,1)
    if (precond("!A76"));

# Crew Quarters
$A63 = $A76 if (precond("!A63"));

# Oar Grade
$A56pre = $ {$type{$A72}}[7];

# Oarsmen
$A55 = " " if (precond("!A55"));

# Hull Factor
$A50pre = $ {$type{$A72}}[8];
$A40 = " " if (precond("!A40"));
$A41 = " " if (precond("!A41"));
if ($kamba) {
    $A50pre += 10;
    $A6pre = round(1.2 * $A6pre);
    $A7pre = round(1.2 * $A7pre);
}

# Tightness
$A42pre = $ {$type{$A72}}[10] + $A13;
if (precond("!A43")) {
    $A43 = " ";
    $A43 = d(30) if ($leakage);
}
$A44 = " " if (precond("!A44"));
$A57 = " " if (precond("!A57"));

# Mast type
if ($A14 =~ /"fir"/) { $A7pre = round(1.05 * $A7pre); $A45 += 5; }

# Spares
$A82 = 0 if (precond("!A82"));

# Anchors
$A81 = 1 if (precond("!A81"));

if ($A81 =~ /(\d+)/) {
    $A7pre += ($1 - 1) * $A62;
}

# Slave shelves
$A80 = 0 if (precond("!A80"));

if ($A80 =~ /(\d+)/) {
    $A6pre += 7 * $1;
    $A7pre += 42 * $1;
}

# Castles
$A79 = 0 if (precond("!A79"));

if ($A79 =~ /(\d+)/) {
    $A6pre += round($A62 * .02 * 5 * $1);
    $A7pre += round($A62 * .02 * 30 * $1);
}

# Others
$A78 = " " if (precond("!A78"));
$A77 = " " if (precond("!A77"));
$A69 = " " if (precond("!A69"));

# Net Burden
$A68pre = $A62;
$A68pre -= $1 * .5 if ($A63 =~ /(\d+)/);
$A68pre -= $1 if ($A64 =~ /(\d+)/);
$A68pre -= $1 if ($A65 =~ /(\d+)/);
$A68pre -= $1 if ($A66 =~ /(\d+)/);
$A68pre -= $1 if ($A67 =~ /(\d+)/);
$A68pre -= $1 * .1 if ($A82 =~ /(\d+)/);
if ($A81 =~ /(\d+)/) {
    my $t = $1 - 10 * $A65;
    $A68pre -= ($t > 0) ? $t : 0;
}
$A68pre -= $1 * .25 if ($A81 =~ /(\d+)/);
$A68pre -= $1 * $A62 *.02 if ($A79 =~ /(\d+)/);

$A68pre = round($A68pre);

### Shakedown

($sk) = ($A2 =~ /(\d+)/);
$si = int($sk/10);
$si = 0 if ($si < 0); $si = 12 if ($si > 12);

# Hull
$A50pre = round($A50pre * $skill[$si][vat($sk)]);

# Tightness
$A42pre = round($A42pre * $skill[$si][vat($sk)]);

# Rigging
$A45pre = round($A45pre * $skill[$si][vat($sk)]);

# Sailing Grade

$A49pre2 = round($ {$type{$A72}}[5] * $skill[$si][vat($sk)]);
if ($A49pre2 <= $grades[0]) { $A49pre2 = "E" }
elsif ($A49pre2 <= $grades[1]) { $A49pre2 = "D" }
elsif ($A49pre2 <= $grades[2]) { $A49pre2 = "C" }
elsif ($A49pre2 <= $grades[3]) { $A49pre2 = "B" }
else { $A49pre2 = "A" }

# Sail MPs
($A51pre,$A52pre,$A53pre) =
    ($wspeed{$A49pre}[$A49pre2-"A"] =~ m%(\d+)/(\d+)/(\d+)%);
$A51 = $A51pre if (precond("!A51"));
$A52 = $A52pre if (precond("!A52"));
$A53 = $A53pre if (precond("!A53"));

# Oar Grade
$A56pre = $ {$type{$A72}}[7];
$A56pre = round($A56pre * $skill[$si][vat($sk)])
    if $A56pre ne "-";
if ($A56pre eq "-" ) { $A54 = "-" if (precond("!A54")); }
elsif ($A56pre <= $grades[0]) { $A56pre = "E" }
elsif ($A56pre <= $grades[1]) { $A56pre = "D" }
elsif ($A56pre <= $grades[2]) { $A56pre = "C" }
elsif ($A56pre <= $grades[3]) { $A56pre = "B" }
else { $A56pre = "A" }

# Oar MPs
$A54 = 2 + ord($A56pre) - ord("A") if (precond("!A54"));

# Time
$A91 = 1 if (!($A91 > 0));
$A6pre = round($A6pre / $A91 * $skill[$si][vat($sk)] * $A90);

## FINALS

# Shipwright
$A2 =~ s/\[.*\]//g;

# Vessel Cost
$A7 = $A7pre if (precond("!A7"));
$A7 = round($A7 * 1.1) if ($rr ne "");

# Total Mandays
$A6 = $A6pre if (precond("!A6"));
$A6 = round($A6 * 1.1) if ($rr ne "");

# Total Cabins
$A22 = $A22pre if (precond("!A22"));

# Total Aboard
$A26 = $A26pre if (precond("!A26"));

# Hull
$A50 = $A50pre if (precond("!A50") || ($rr eq "H"));

# Tightness
$A42 = $A42pre if (precond("!A42") || ($rr eq "T"));

# Rigging
$A45 = $A45pre if (precond("!A45") || ($rr eq "R"));

# Sailing Grade
$A49 = $A49pre2."(".$A49pre.")" if (precond("!A49") || ($rr eq "SG"));

# (SQs)
$A61 = round(1*$A45/5) if (precond("!A61"));
$A60 = round(2*$A45/5) if (precond("!A60"));
$A58 = round(3*$A45/5) if (precond("!A58"));
$A59 = round(4*$A45/5) if (precond("!A59"));

# Oar Grade
$A56 = $A56pre if (precond("!A56") || ($rr eq "OG"));

# Net Burden
$A68 = $A68pre if (precond("!A68"));

# Date of Launching
$A4 = adddate(round(.7 * $A6),"1.1.720") if (precond("!A4") || ($rr ne ""));

# Date of Comission
$A5 = adddate(round($A6),"1.1.720") if (precond("!A5") || ($rr ne ""));

# Expiry Date
$A74 = $A5 if (precond("!A74"));

### CREW

$B21 = "Captain" if (precond("!B21"));

#########
### SUBS
#########

sub d { return 1 + int rand @_[0]; }

sub precond { $_ = shift; s/([A-Za-z0-9]+)/"defined(\$$1)"/eg; return eval; }

sub round { return sprintf "%d", @_[0] + .5; }

sub adddate {
    my ($n, $d) = @_;
    $d =~ /(\d+)\.(\d+)\.(\d+)/;
    $nd = $n + ($1-1) + 30*($2-1) + 12*30*($3-1);
    $s = (1+$nd%30).".".int(1+($nd/30)%12).".".(1+int($nd/(12*30)));
}

sub vat {
    my $t = d(100);
    return 0 if (($t <= @_[0]) && (!($t%5)));
    return 1 if ($t <= @_[0]);
    return 2 if (!($t%5));
    return 3;
}

#########
### OUTPUT
#########

foreach (1..90) {
    ${"A$_"} = " " if (precond("!A$_"));
}
foreach (1..110) {
    ${"B$_"} = " " if (precond("!B$_"));
}

$gs = "| gs -q -dNOPAUSE -dBATCH -sDEVICE=\$d -sOutputFile=- -c save pop -";

# PREPARE (STD)OUT

%action = ("HTML" => [".html","text/html"],
	   "PS" => [".ps","application/postscript"],
	   "FIG" => [".fig","application/fig"],
	   "JPEG" => [".ps","image/jpeg"],
	   "PDF" => [".ps","application/pdf"],
	   "FORM" => ["f.html","text/html"]);

open(FILE, "<".$FILE_LOCATION."vessel".$action{$q->param("action")}[0]) ||
    die "Can't open file: $! :".$FILE_LOCATION."vessel".$action{$q->param("action")}[0];
print $q->header(-type => $action{$q->param("action")}[1],
		 -attachment => "vessel".$action{$q->param("action")}[0]);

if ($q->param("action") eq "HTML") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "PS") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "FIG") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "PDF") {
    $d = "pdfwrite"; $gs =~ s/\$d/$d/;
    open PDF, $gs;
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print PDF $i;
    }
    close(PDF);
}
if ($q->param("action") eq "JPEG") {
    $d = "jpeggray -r141"; $gs =~ s/\$d/$d/;
    open PDF, $gs;
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print PDF $i;
    }
    close(PDF);
}
if ($q->param("action") eq "FORM") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)\" value=\"/\$$1\" value=\"$ {"$1"}/;
	print $i;
    }
}
close(FILE);
